



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>从一道面试题分析javascript闭包</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">从一道面试题分析javascript闭包</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 01:30:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>据说是一不注意就会做错的五道javascript面试题之一，我们来看看这道题长什么样</p>
<div>
<pre class="prettyprint linenums">function Container( properties ) {<br />
    var objthis = this;<br />
    for ( var i in properties ) {<br />
        (function(){<br />
                var t = properties[i];<br />
                objthis[ "get" + i ] = function() {return t;};<br />
                objthis[ "set" + i ] = function(val) {t = val;};<br />
        })();<br />
    }<br />
}  

var prop = {Name : "Jim", Age : 13};<br />
var con = new Container(prop);<br />
console.log(con.getName());  

con.setName("Lucy");<br />
console.log(con.getName());<br />
console.log(prop.Name);  </pre>
</div>
<p>现在请写出每次console.log的输出结果：()</p>
<p>A: Jim,Lucy,Lucy &nbsp;B: Jim,Jim,Jim C : Lucy ,Lucy,Lucy D: Jim,Lucy,Jim</p>
<p>如果你选了D,排除运气的成份，你可以不用往下看了，因为可以确定你是资深老手了。</p>
<p>如果是选的别的选项，请继续看下面的分析。</p>
<p>首先大概扫瞄一下整个Container函数：函数的作用应当是想要给传进来的对象的每一个属性都添加一个get和 set 的方法。</p>
<p>下面开始从上至下的逐行分析：</p>
<div>
<pre class="prettyprint linenums">function Container( properties ) {<br />
    var objthis = this;  // 用objthis 保存对this的引用<br />
    for ( var i in properties ) {  //循环properties中的内容<br />
        (function(){<br />
          //这里就是闭包所创建的空间<br />
          // 闭包内声明一个局部变量保存存properties中的值<br />
                var t = properties[i];<br />
                //在objthis对象上添加两个方法<br />
                objthis[ "get" + i ] = function() {return t;};<br />
                objthis[ "set" + i ] = function(val) {t = val;};<br />
        })();  //创建一个立即执行函数,目的是形成一个闭包，因为我们知道，闭包的作用是即使外层函数调用后，由于闭包引用的关系，外层函数不会被立即回收，因此闭包函数还可以继续使用外层函数所声明的变量和方法。<br />
    }<br />
}  </pre>
</div>
<pre class="prettyprint linenums">var prop = {Name : "Jim", Age : 13};<br />
var con = new Container(prop);<br />
console.log(con.getName());  // Jim

con.setName("Lucy");<br />
console.log(con.getName());  // Lucy<br />
</pre>
<p>初看起来，没有什么问题，那这个坑到底在哪里呢？</p>
<p>如果我们继续打印&nbsp;console.log(prop.Name); // Jim</p>
<p>是不是感到很惊讶？为什么&nbsp;con.getName() 得到Lucy,而prop.Name 得到Jim ?</p>
<p>===============================================================</p>
<p>我们先从这个立即执行函数看起，如果省略它，那么t始终都是循环之后的值。这个立即执行函数就是为了解决这个问题的，所以这也没有什么问题。</p>
<p>然后就是这个objthis,它是Container实例的一个内部指针，和&nbsp;properties 没有什么关系，但是properties 和prop是有关系的。因为prop是对象</p>
<p>是引用类型的，所以properties 可以看成是prop引用的一个副本（关于javascript的传参，后面再细说）。所以在Container内部，能过修改properties</p>
<p>是可以改变prop本身的，当然也可以访问到prop的属性。</p>
<p>我来看看</p>
<p>var con = new Container(prop);  这个con到底有什么内容</p>
<ol><li>getAge:&nbsp;function () {return t;}</li>
<li>setAge:&nbsp;function (val) {t = val;}</li>
<li>getName:&nbsp;function () {return t;}</li>
<li>setName:&nbsp;function (val) {return t;}</li></ol>
<p>看来con是根据prop的属性名，生成了对应的set/get方法，但是方法体内找不到properties的痕迹。里边只有一个t,而</p>
<p>t=properties[i], 这不就是prop.Name或prop.Age的值吗？我第一反应就是这个set方法有问题。t = val; 根据对象属性赋值的常识</p>
<p>var t = prop.Name, t = 'xxx', prop.Name的值是肯定不会改变的。这改变的仅仅是t自己。</p>
<pre class="prettyprint linenums">con.setName("Lucy");<br />
console.log(con.getName());  // Lucy<br />但是为什么这里又更改生效了呢？</pre>
<p>我在这个地方郁闷了很久，我自己没有想清楚，最后还是请教了一位资深前辈才搞清楚。</p>
<p>原因很简单，因为con上的set和get方法，访问的都是闭包内的t的值。与properties没有半毛钱关系了。</p>
<pre class="prettyprint linenums">con.setName("Lucy"); 相当于 t = "Lucy" ,而con.getName相当于 return t; 这是再普通不过的道理了。</pre>
<p>这样也就很好的解释了，为什么&nbsp;con.getName() 的值是Lucy,而prop.Name还是jim.</p>
<p>为什么我会产生那样的困惑呢？原因就在于没有搞清楚这个t，没有弄明白闭包的用法。那现在要怎么修改，才能实现Container最初的意图呢？</p>
<p>既然明白了con.setName修改的是自身的t，con.getName访问的也是自身的t，那么只人把这个t换成prop.Name就好了。</p>
<p>下面是我修改后的代码：</p>
<div>
<pre class="prettyprint linenums">function Container( properties ) {<br />
    var objthis = this;<br />
    for ( var i in properties ) {<br />
        (function(){<br />
                var name = i;<br />
                objthis[ "get" + i ] = function() {return properties[name];};<br />
                objthis[ "set" + i ] = function(val) {properties[name] = val;};<br />
        })();<br />
    }<br />
}</pre>
</div>
<p>con.setName('frog')<br />console.log(prop.Name,con.getName());</p>
<p>// frog frog</p>
<p>======================================================================</p>
<p>关于javascript中的参数的传递。</p>
<p>根据我们c语言的知识，参数的传递有两种方式，按引用传递和按值传递。</p>
<p>但是javascript中所以的参数都是按值传递的。即便参数是对像也是如此。</p>
<p>function fun(a){</p>
<p>}</p>
<p>var o = {name:'frog'}</p>
<p>fun(o);</p>
<p>fun(o/*这里的o其实是复制了o对象的一个引用*/)</p>
<p>这不是本篇的重点，只是提一下。不明白的私信我或查阅相关资料。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy143jq.html">JAVA基础 Exception&comma; Error</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdm768.html">【Alpha】阶段汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r1ry78.html">AutoVue打开ProE工程图中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r6gk49.html">深入理解Memcache原理 &lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q263239.html">Linux mke2fs 硬盘格式化</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzdkrq.html">Shell命令&lowbar;正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrlgjq.html">浅谈checkpoint与内存缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq17224q.html">Linux内核同步机制--转发自蜗窝科技</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1e71z9.html">hdwiki model目录下的函数类</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xy5609.html">Linux进程间通信-信号</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjkmj49.html">hql查询语句 内存中的情况，fetch迫切查询关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xvpgz9.html">http 会话&lpar;session&rpar;详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwj3k9.html">java&period;text&period;ParseException&colon; Unparseable date&colon; &amp;quot&semi;2015-06-09 hh&colon;56&colon;19&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zl1kn9.html">学习---&amp;gt&semi;更新集合&sol;内存&sol;深浅拷贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw31gk8.html">java jdk 打开出错 Failed to load the JNI shared library</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyerjgq.html">制作openstack使用的Ubuntu镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em0p4k9.html">前端 html input标签  placeholder属性 标签上显示内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4v4m1q.html">002-ubuntu安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1we269.html">grafana安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/963n60y9.html">L205 EE</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49504z08.html">Linux Shell 通配符、元字符、转义符【转帖】</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv1x1zq.html">Dertouzos  &lpar;5750&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pdzmd9.html">ajax的一些笔试面试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyywdgq.html">为什么commonjs不适合于浏览器端</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m2nvpq.html">while&lpar;cin&period;eof&rpar;出错 poj</a>
			</li>
						<li><a href="https://www.batexi.com/a/495g0xvq.html">一篇关于匿名函数&lpar;function&lpar;&rpar;&lbrace;&rcub;&rpar;&lpar;&rpar;不错的文章</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zyvv39.html">SEO：让搜索引擎对你的网站更有亲和力&lpar;译&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxdlyv9.html">&lbrack;&period;net 面向对象程序设计进阶&rsqb; &lpar;25&rpar; 团队开发利器（四）分布式版本控制系统Git&mdash;&mdash;使用GitStack&plus;TortoiseGit 图形界面搭建Git环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/495gpl0q.html">java中文乱码解决之道（三）-----编码详情：伟大的创想---Unicode编码</a>
			</li>
						<li><a href="https://www.batexi.com/a/495gm0zq.html">AngularJs项目文件以及文件夹结构</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
